-- заблочник, иногда контратакует отбивами
blocker = { }

function blocker.init(me)
	me.mind.period = 0.25 / me.speed
	me.skills['pc'] = false
	debuginfo.text = ""
	me.mind.ai_state = AI_ATTACK
	me.mind.debugtext = ""
end

local too_close, too_far = 12, 20

function blocker.update_state(me, enemy, dt)
	-- дистанция
	me.mind.dist_state = DIST_NORMAL
	if (me.mind.dist > too_far) then
		me.mind.dist_state = DIST_FAR
	end
	if (me.mind.dist < too_close) then
		me.mind.dist_state = DIST_CLOSE
	end
	-- защищаться или атаковать?
	if (me.mind.ai_state == AI_ATTACK and me.energy < 50) then
		me.mind.ai_state = AI_DEFEND
		return
	end
	if (me.mind.ai_state == AI_DEFEND and me.energy > 70) then
		me.mind.ai_state = AI_ATTACK
		return
	end
end

local random_value

function blocker.update_action(me, enemy, dt)
	param_side = me.mind.side > 0
	
	if (me.mind.dist_state == DIST_FAR and me.state == 'step') then me:action('stop') end
	
	-- если противник оказался с другой стороны => разворачиваемся
	if (me.side ~= me.mind.side) then
		boxer.reset_actions(me)
		me:action('reverse');
		return
	end
	--[[
	-- при получении урона бьем джеб в контр-атаке
	if (me.state == 'damage') then
		boxer.reset_actions(me)
		me:action('jab');
		return
	end
	--]]
	-- АТАКА
	if (me.mind.ai_state == AI_ATTACK) then
		-- нужно предпринять новое действие
		if (me.state == nil) then
			-- если стоим слишком близко => отходим назад
			if (me.mind.dist_state == DIST_CLOSE or me.mind.dist_state == DIST_NORMAL) then
				-- у нас преимущество по энергии - атакуем
				if (me.energy > enemy.energy) then
					if (enemy.state == 'jab' or enemy.state == 'cross') then
						me:action('weave');
					else
						if (math.random() > 0.4) then me:action('jab', false); else me:action('cross', false); end
					end
				else
					me:action('block', true);
				end
			else
				--
				-- без блока подходим ближе к сопернику
				if (me.mind.dist_state == DIST_FAR) then
					me:action('move', param_side); me:action('stop')	-- шаг вперед
				end
			end
		else
			-- держим блок
			if (me.state == 'block' or me.state == 'block_up' or me.state == 'block_down') then
				if (me.energy > enemy.energy + 40) then
					me:action('block', false);
				end
				-- отходим назад
				if (me.mind.dist_state == DIST_CLOSE) then
					me:action('move', not param_side); me:action('stop')
				end
				-- сближаемся
				if (me.mind.dist_state == DIST_FAR) then
					me:action('block', false);
					me:action('move', param_side); me:action('stop') -- шаг вперед
				end
				-- действуем!
				if (me.mind.dist_state == DIST_NORMAL) then
					-- делаем отбивы
					if (enemy.state == 'jab') then
						me.mind.debugtext = "beatoff_jab"
						me:action('beatoff', false);
					end
					if (enemy.state == 'cross') then
						me:action('beatoff', true);
					end
					-- контратакуем
					if (enemy.state == 'failure') then
						me:action('block', false);
						if (math.random() > 0.4) then me:action('jab', false); else me:action('cross', false); end
					end
				end
			end
		end
		return
	end
	
	-- ЗАЩИТА
	if (me.mind.ai_state == AI_DEFEND) then
		if (me.state == nil) then
			-- бежим назад
			if (me.mind.dist_state == DIST_CLOSE or me.mind.dist_state == DIST_NORMAL) then
				me:action('swoop', not param_side);
			end
		else
			-- снимаем блок, если до этого его держали
			if (me.state == 'block' or me.state == 'block_up' or me.state == 'block_down') then
				me:action('block', false);
			end
		end
		return
	end
	
end