counter = { }

function counter.init(me)
	me.mind.period = 0.2 / me.speed
	me.skills['pc'] = false
	debuginfo.text = ""
end

local too_close = 13
local too_far = 18

function counter.update_state(me, enemy, dt)
	if (me.mind.dist > 15) then
		me.mind.state = AI_STEP
		return
	end
	if (me.mind.dist < too_close) then
		me.mind.state = AI_BACK
		return
	end
	if (enemy.state == 'jab' or enemy.state == 'cross') then
		me.mind.state = AI_DEFEND
		return
	end
	me.mind.state = AI_ATTACK
end

local random_value

function counter.update_action(me, enemy, dt)
	param_side = me.mind.side > 0
	
	-- исправляем баг с вечным шагом назад
	if (me.mind.dist > too_far + 2 and me.state == 'step') then
		me:action('stop')
	end
	
	-- если противник оказался с другой стороны => разворачиваемся
	if (me.side ~= me.mind.side) then
		boxer.reset_actions(me)
		me:action('reverse');
		return
	end
		
	-- слишком близко, делаем 1 шаг назад
	if (me.mind.state == AI_BACK) then
		if (enemy.state == 'swoop' and enemy.dir_move ~= me.side) then
			me:action('jab')
		else
			me:action('move', not param_side); me:action('stop')
		end
		return
	end	
	if (me.state == nil) then
		-- противник ничего не делает
		if (enemy.state == nil) then
			-- слишком далеко, делаем 1 шаг на игрока
			if (me.mind.state == AI_STEP) then
				me:action('move', param_side); 	me:action('stop')
			end
			-- слишком близко, делаем 1 шаг назад
			if (me.mind.state == AI_BACK) then
				me:action('move', not param_side); me:action('stop')
			end
			if (me.mind.state == AI_ATTACK) then
				if (math.random() < (me.energy/me.max_energy)) then
					me:action('jab')
				end
			end
		else	-- противник что-то делает
			if (me.mind.dist > too_far) then
				me:action('move', param_side); 	me:action('stop')
			end
			-- мы можем атаковать
			if (me.mind.state == AI_ATTACK) then
				-- и противник идет на нас
				if (enemy.dir_move ~= me.side) then
					if (enemy.state == 'step') then me:action('jab') end
				else
					-- противник отскочил назад
					if (enemy.state == 'swoop') then me:action('cross') end
				end
			end
		end
		
		-- противник выбросил удар - защищаемся
		if (me.mind.state == AI_DEFEND) then
			if (enemy.state == 'jab') then
				if (me.mind.dist > too_close) then
					if (math.random() < (me.energy/me.max_energy)) then
						me:action('cross', false)
					end
				else
					me:action('move', not param_side); me:action('stop')	-- шаг назад
				end
				return
			end
			-- противник бьет джеб
			if (enemy.state == 'cross') then
				if (math.random() < (me.energy/me.max_energy)) then
					if (clip.get_frame(enemy) < 3) then
						me:action('jab')	-- джеб навстречу
					else
						me:action('weave'); me:action('cross', false)
					end
				else
					me:action('move', not param_side); me:action('stop')
				end
				return
			end
		end
		
	else
		-- при получении урона бьем джеб в контр-атаке
		if (me.state == 'damage') then
			me:action('jab');
			if (math.random() < 0.3) then me:action('swoop', false); end
		end
		if (me.mind.state == AI_DEFEND) then
			-- противник выбросил джеб во время нашего шага => отпрыгиваем назад
			if (me.state == 'step' and enemy.state == 'jab') then
				me:action('move', not param_side); me:action('stop')
			end
		end
	end
end