counter = { }

function counter.init(me)
	me.mind.period = 0.3
	me.skills['pc'] = false
	debuginfo.text = ""
end

local too_close, too_far = 13, 18

function counter.update_state(me, enemy, dt)
	-- дистанция
	me.mind.dist_state = DIST_NORMAL
	if (me.mind.dist > too_far) then
		me.mind.dist_state = DIST_FAR
	end
	if (me.mind.dist < too_close) then
		me.mind.dist_state = DIST_CLOSE
	end
	-- защищаться или атаковать?
	if (enemy.state == 'jab' or enemy.state == 'cross') then
		me.mind.ai_state = AI_DEFEND
	else
		me.mind.ai_state = AI_ATTACK
	end
end

local random_value

function counter.update_action(me, enemy, dt)
	param_side = me.mind.side > 0
	
	-- если противник оказался с другой стороны => разворачиваемся
	if (me.side ~= me.mind.side) then
		boxer.reset_actions(me)
		me:action('reverse');
		return
	end
	
	-- при получении урона бьем джеб в контр-атаке
	if (me.state == 'damage') then
		me:action('jab');
		if (math.random() < 0.3) then me:action('swoop', -me.side); end
		return
	end

	-- если стоим слишком близко => отходим назад
	if (me.state == nil and me.mind.dist_state == DIST_CLOSE) then
		if (enemy.state == 'swoop' and enemy.dir_move == me.side) then
			me:action('jab')
		else
			me:action('move', not param_side); me:action('stop')
		end
		return
	end	
	
	-- АТАКА
	if (me.mind.ai_state == AI_ATTACK) then
		-- противник ничего не делает
		if (enemy.state == nil) then
			-- слишком далеко, делаем 1 шаг на игрока
			if (me.mind.dist_state == DIST_FAR) then
				me:action('move', param_side); 	me:action('stop')
			else
				if (math.random() < (me.energy/me.max_energy)) then
					me:action('jab')
				end
			end
		else
		-- противник что-то делает
			if (me.mind.dist_state == DIST_FAR) then
				-- противник идет на нас
				if (enemy.dir_move ~= me.side) then
					if (enemy.state == 'step') then me:action('jab') end
					if (enemy.state == 'swoop' and enemy.dir_move ~= me.side) then me:action('cross') end
				else
					me:action('move', param_side); 	me:action('stop')
				end
			end
		end
		return
	end
	
	-- ЗАЩИТА
	if (me.mind.ai_state == AI_DEFEND) then
		if (me.state == nil) then
			-- противник бьет джеб
			if (enemy.state == 'jab') then
				if (me.mind.dist_state == DIST_NORMAL) then
					if (math.random() < (me.energy/me.max_energy)) then me:action('cross', false) end
				else
					me:action('move', not param_side); me:action('stop')	-- шаг назад
				end
			end
			-- противник бьет кросс
			if (enemy.state == 'cross') then
				if (math.random() < (me.energy/me.max_energy)) then
					if (clip.get_frame(enemy) < 3) then me:action('jab')	-- джеб навстречу
					else me:action('weave'); me:action('cross', false) end -- уклон
				else
					me:action('move', not param_side); me:action('stop')	-- шаг назад
				end
				return
			end
		else
			-- противник выбросил джеб во время нашего шага => отпрыгиваем назад
			if (me.state == 'step' and enemy.state == 'jab') then
				me:action('move', not param_side); me:action('stop')
			end
		end
		return
	end
	
end