-- игровик, работающий с дистанции
playman = { }

function playman.init(me)
	me.mind.period = 0.25 / me.speed
	me.skills['pc'] = false
	debuginfo.text = ""
	me.mind.ai_state = AI_ATTACK
	me.index = 0
	me.dance_phase = 1
	--me.mind.debugtext = ""
end

local too_close, stop_back, too_far = 12, 16, 20

function playman.update_state(me, enemy, dt)
	-- дистанция
	me.mind.dist_state = DIST_NORMAL
	if (me.mind.dist > too_far) then me.mind.dist_state = DIST_FAR end
	if (me.mind.dist < too_close) then me.mind.dist_state = DIST_CLOSE end
	-- защищаться или атаковать?
	me.mind.ai_state = AI_ATTACK
	if (enemy.state == 'jab' or enemy.state == 'cross') then me.mind.ai_state = AI_DEFEND; return end
end

local random_value, act

function playman.update_action(me, enemy, dt)
	param_side = me.mind.side > 0
	-- если отступаем и не сработал "стоп", то останавливаемся
	if (me.mind.dist > stop_back and me.state == 'step' and (me.dir_move > 0 ~= me.side)) then
		me:action('stop');
		return
	end
	-- если противник оказался с другой стороны => разворачиваемся
	if (me.side ~= me.mind.side) then
		boxer.reset_actions(me)
		me:action('reverse')
		return
	end
	-- при получении урона делаем шаг назад
	if (me.state == 'damage') then
		boxer.reset_actions(me)
		me:action('move', not param_side); me:action('stop')
		return
	end

	-- АТАКА
	if (me.mind.ai_state == AI_ATTACK) then
		if (me.state == nil) then
			-- на ближней дистанции обходим противника с другой стороны
			-- отступаем назад, если соперник повернут к нам спиной
			if (me.mind.dist_state == DIST_CLOSE) then
				if (me.energy - enemy.energy > 30) then me:action('jab')
				else
					if (me.side ~= enemy.side) then me:action('swoop', param_side) else me:action('swoop', not param_side) end
				end
				return
			end
			-- сближаемся
			if (me.mind.dist_state == DIST_FAR) then
				me:action('move', param_side); me:action('stop')
				return
			end
			-- средняя дистанция
			if (me.mind.dist_state == DIST_NORMAL) then
				-- мы свежее соперника, игнорируем программу
				if (me.energy - enemy.energy > 30) then
					if (math.random() > 0.7) then me:action('jab') else me:action('cross') end
					return
				end
				-- выполняем челнок
				if (me.dance_phase == 1) then
					me:action('move', param_side); me:action('stop')
					me.mind.debugtext = "2"
					me.dance_phase = 2
					return
				end
				if (me.dance_phase == 2) then
					me:action('move', not param_side); me:action('stop')
					me.mind.debugtext = "1"
					me.dance_phase = 1
					return
				end
			end
			return
		else
			if (me.mind.dist > 14 and me.energy > 75) then
				-- иногда выбрасываем двойной джеб
				if (me.state == 'jab') then
					if (math.random() > 0.7) then me:action('jab') end
					return
				end
				-- бьем только в челноке когда противник двигается
				if (enemy.state ~= nil) then
					if (me.dance_phase == 2) then me:action('jab') end
					if (me.dance_phase == 1) then me:action('cross', false) end			
				end
			end
		end
	end
	
	-- ЗАЩИТА
	if (me.mind.ai_state == AI_DEFEND) then
		if (me.state == nil) then
			-- если противник устал - бьем те же удары навстречу
			if (me.energy - enemy.energy > 40) then
				if (enemy.state == 'jab') then me:action('jab') end
				if (enemy.state == 'cross') then me:action('cross') end
			else
				-- если стоим слишком близко => отходим назад
				if (me.mind.dist_state == DIST_CLOSE) then
					if (enemy.energy > 50) then
						if (clip.get_frame(enemy) > 0) then me:action('weave') end
					else
						me:action('swoop', not param_side)
					end
				end
				-- на нормальной дистанции отскок назад
				if (me.mind.dist_state == DIST_NORMAL) then me:action('swoop', not param_side); me:action('stop') end
			end
		end
		return
	end
	
end