-- игровик, работающий с дистанции
spoiler = { }

function spoiler.init(me)
	me.mind.period = 0.15 / me.speed
	me.skills['pc'] = false
	debuginfo.text = ""
	me.mind.ai_state = AI_ATTACK
end

local too_close, stop_back, too_far, very_far = 12, 16, 18, 26

function spoiler.update_state(me, enemy, dt)
	-- дистанция
	me.mind.dist_state = DIST_NORMAL
	if (me.mind.dist > very_far) then me.mind.dist_state = DIST_VERY_FAR
	else
		if (me.mind.dist > too_far) then me.mind.dist_state = DIST_FAR end
		if (me.mind.dist < too_close) then me.mind.dist_state = DIST_CLOSE end	
	end
	-- защищаться или атаковать?
	me.mind.ai_state = AI_ATTACK
	if (enemy.state == 'jab' or enemy.state == 'cross') then me.mind.ai_state = AI_DEFEND; return end
end

local random_value, act

function spoiler.update_action(me, enemy, dt)
	param_side = me.mind.side > 0
	-- если отступаем и не сработал "стоп", то останавливаемся
	if (me.mind.dist > stop_back and me.state == 'step' and (me.dir_move > 0 ~= me.side)) then
		me:action('stop');
		return
	end
	-- если противник оказался с другой стороны => разворачиваемся
	if (me.side ~= me.mind.side) then
		boxer.reset_actions(me)
		me:action('reverse')
		return
	end
	-- при получении урона бросаем джеб навстречу
	if (me.state == 'damage') then
		boxer.reset_actions(me)
		me:action('jab')
		return
	end

	-- АТАКА
	if (me.mind.ai_state == AI_ATTACK and me.state == nil) then
		-- сближаемся бегом
		if (me.mind.dist_state == DIST_VERY_FAR) then
			me:action('swoop', param_side)
			return
		end
		-- сближаемся шагом
		if (me.mind.dist_state == DIST_FAR) then
			me:action('move', param_side); me:action('stop')
			return
		end
		-- средняя дистанция
		if (me.mind.dist_state == DIST_NORMAL) then
			-- мы свежее соперника, спокойно бьем удары
			if (me.energy - enemy.energy > 30) then
				if (me.mind.dist < stop_back) then
					if (math.random() > 0.7) then me:action('jab') else me:action('cross') end
					return
				end
			else
				-- противник идет на нас
				if (me.energy > 50) then
					if (me.mind.dist < stop_back) then
						if (enemy.state == 'step' and enemy.dir_move > 0 ~= me.side) then
							me:action('jab')
						end
					end
				end
			end
			return
		end
		-- на ближней дистанции обходим противника с другой стороны
		-- отступаем назад, если соперник повернут к нам спиной
		if (me.mind.dist_state == DIST_CLOSE) then
			if (me.energy - enemy.energy > 30) then
				me:action('jab')
			else
				if (me.side ~= enemy.side) then me:action('swoop', param_side)
				else
					me:action('jab')
					me:action('swoop', not param_side)
				end
			end
			return
		end
	end
	
	-- ЗАЩИТА
	if (me.mind.ai_state == AI_DEFEND) then
		if (me.state == nil) then
			-- если противник устал - бьем те же удары навстречу
			if (me.energy - enemy.energy > 40) then
				if (enemy.state == 'jab') then me:action('jab') end
				if (enemy.state == 'cross') then me:action('cross') end
			else
				-- если стоим слишком близко => отходим назад
				if (me.mind.dist_state == DIST_CLOSE) then
					if (clip.get_frame(enemy) > 0) then me:action('weave') end
				end
				-- на нормальной дистанции отскок назад
				if (me.mind.dist_state == DIST_NORMAL) then me:action('swoop', not param_side); me:action('stop') end
			end
		end
		return
	end
	
end