-- темповик, выбрасывающий удары пока не устанет
-- потом уходит в защиту пока не отдохнет
swarmer = { }

function swarmer.init(me)
	me.mind.period = 0.3 / me.speed
	me.skills['pc'] = false
	debuginfo.text = ""
	me.mind.ai_state = AI_ATTACK
	me.mind.debugtext = ""
end

local too_close, too_far = 12, 21

function swarmer.update_state(me, enemy, dt)
	-- дистанция
	me.mind.dist_state = DIST_NORMAL
	if (me.mind.dist > too_far) then
		me.mind.dist_state = DIST_FAR
	end
	if (me.mind.dist < too_close) then
		me.mind.dist_state = DIST_CLOSE
	end
	-- защищаться или атаковать?
	if (me.mind.ai_state == AI_ATTACK and me.energy < 30) then
		me.mind.ai_state = AI_DEFEND
		me.mind.debugtext = "defend"
		return
	end
	if (me.mind.ai_state == AI_DEFEND and me.energy > 70) then
		me.mind.ai_state = AI_ATTACK
		me.mind.debugtext = "attack"
		return
	end
end

local random_value

function swarmer.update_action(me, enemy, dt)
	param_side = me.mind.side > 0
	
	-- если противник оказался с другой стороны => разворачиваемся
	if (me.side ~= me.mind.side) then
		boxer.reset_actions(me)
		me:action('reverse');
		return
	end
	
	-- при получении урона бьем джеб в контр-атаке
	if (me.state == 'damage') then
		boxer.reset_actions(me)
		me:action('jab');
		return
	end

	-- АТАКА
	if (me.mind.ai_state == AI_ATTACK) then
		if (me.state == nil) then
			-- шаг назад когда подошли слишком близко
			if (me.mind.dist_state == DIST_CLOSE) then
				me:action('move', not param_side); me:action('stop')
			end
			
			if (me.mind.dist_state == DIST_CLOSE or me.mind.dist_state == DIST_NORMAL) then
				-- джеб по идущему на нас сопернику
				if (enemy.state == 'step' and enemy.dir_move ~= me.side) then
					me:action('jab');
				end
				-- делаем уклон если соперник выбросил удар
				if (me.prev_state ~= 'weave' and enemy.state == 'cross' and clip.get_frame(enemy) > 1) then
					me:action('weave');
					return
				end
			end
			-- на норм. дистанции бьем джеб или отходим назад
			if (me.mind.dist_state == DIST_NORMAL) then
				if (me.mind.dist < 17) then
					if (math.random() < 0.7) then me:action('jab') else me:action('cross') end
				else
					me:action('move', param_side); me:action('stop')	-- шаг вперед
				end
			end
			-- если слишком далеко - то бежим прямо к сопернику
			if (me.mind.dist_state == DIST_FAR) then
				me:action('swoop', param_side);
			end
		end
		return
	end
	
	-- ЗАЩИТА
	if (me.mind.ai_state == AI_DEFEND) then
		if (me.state == nil) then
			-- если стоим слишком близко => отходим назад
			if (me.mind.dist_state == DIST_CLOSE) then
				me:action('swoop', not param_side); me:action('stop')
			end
			if (me.mind.dist_state == DIST_NORMAL) then
				me:action('move', not param_side); me:action('stop')	-- шаг назад
				--me:action('swoop', not param_side); me:action('stop')
			end
			
		end
		return
	end
	
end