tutorial = {
	moves = { "movements", "interrupt", "swoop", "block", "breakoff", "weave", "weave_cross", "double_jab", "power_cross", },
}

local buttons

function tutorial.init(me)
	debuginfo.text2 = 'tutorial.init'
	me.controls_mode = 0	-- управление как у игрока 1
	me.keys = controls.player
	if (buttons == nil) then
		buttons = { }
		buttons.left = resources.get_sprite("gui", "left"); buttons.right = resources.get_sprite("gui", "right")
		buttons.up = resources.get_sprite("gui", "up"); buttons.down = resources.get_sprite("gui", "down")
		buttons.z = resources.get_sprite("gui", "z"); buttons.x = resources.get_sprite("gui", "x")
		buttons.tab = resources.get_sprite("gui", "tab");
	end
	me.used_buttons = { }
	--me.post_draw = tutorial.draw_buttons
	--
	me.mind.start_x = me.x
	me.mind.period = 0.0
	--me.skills['pc'] = true
	me.mind.action = { }
	me.mind.task = { }
	tutorial.start_task(me, 'movements') --'breakoff' 'movements'
	debuginfo.text = ""
end

-- { кнопка,	 нажатие/отпускание,	 через сколько сек. следующее действие в списке }
local programs = {
	-- перемещения и удары
	["movements"] = {
		{ 'left', true, 0.2 }, { 'left', false, 1.0 },
		{ 'right', true, 0.2 }, { 'right', false, 1.0 },
		{ 'z', true, 0.2 }, {'z', false, 1.2 },
		{ 'x', true, 0.2 }, {'x', false, 1.2 },
		{ 'tab', true, 1.0 }, {'tab', false, 0.3 },
		{ 'tab', true, 1.0 }, {'tab', false, 0.3 },
		{ 'none', false, 1.0 }
	},
	-- прерывание движения ударом
	["interrupt"] = {
		--[[
		{ 'left', true, 0.12 }, { 'left', false, 0.1 }, { 'z', true, 0.3 }, { 'z', false, 1.0 },
		{ 'right', true, 0.12 }, { 'right', false, 0.1 }, { 'x', true, 0.3 }, { 'x', false, 1.5 },
		{ 'none', false, 1.0 }
		--]]
		{ 'left', true, 0.12 }, { 'z', true, 0.1 }, { 'left', false, 0.1 }, { 'z', false, 1.0 },
		{ 'right', true, 0.12 }, { 'x', true, 0.1 }, { 'right', false, 0.1 }, { 'x', false, 1.5 },
		{ 'none', false, 1.0 }
	},
	-- наскоки и отскоки
	["swoop"] = {
		{ 'left', true, 0.1 }, { 'left', false, 0.1 }, { 'left', true, 0.1 }, { 'left', false, 1.0 },
		{ 'right', true, 0.1 }, { 'right', false, 0.1 }, { 'right', true, 0.1 }, { 'right', false, 1.0 },
		{ 'none', false, 1.0 },
	},
	-- блок
	["block"] = {
		{ 'up', true, 0.2 }, { 'left', true, 1.5 }, { 'left', false, 1.0 },
		{ 'right', true, 1.5 }, { 'right', false, 1.0 }, { 'up', false, 1.0 },
		{ 'none', false, 1.0 }
	},
	-- отбивы
	["breakoff"] = {
		{ 'up', true, 1.0 },
		{ 'z', true, 0.2 }, { 'z', false, 0.2 }, { 'up', true, 1.0 },
		{ 'x', true, 0.2 }, { 'x', false, 0.2 }, { 'up', true, 1.0 },
		{ 'up', false, 1.5 },
	},
	-- уклон
	["weave"] = {
		{ 'down', true, 0.2 }, { 'down', false, 0.2 },
		{ 'none', false, 1.0 }
	},
	-- выход из блока уклоном и кросс сразу после уклона
	["weave_cross"] = {
		{ 'up', true, 1.0 },
		{ 'down', true, 0.1 }, { 'x', true, 0.1 }, { 'up', false, 0.1 }, { 'down', false, 0.2 }, { 'x', false, 1.0 },
		{ 'none', false, 1.0 }
	},
	-- двойной джеб
	["double_jab"] = {
		{ 'z', true, 0.2 }, { 'z', false, 0.1 }, { 'z', true, 0.1 }, { 'z', false, 1.0 },
		{ 'z', true, 0.1 }, { 'z', false, 0.2 }, { 'z', true, 0.2 }, { 'z', false, 1.0 },
		{ 'none', false, 1.0 }
	},
	-- заряжание кросса
	["power_cross"] = {
		{ 'x', true, 1.0 }, { 'x', false, 1.0 },
		{ 'none', false, 1.0 }
	},

}

function tutorial.start_task(me, new_task)
	me.mind.action = nil
	me.mind.task = { left_t = 0, program = programs[new_task], index = 1 }
	me.x = me.mind.start_x
	controls.reset(me)
	me.used_buttons = { }
	me:reset()
	me.side = -1
end

--[[
task:
	"movements" - основные движения (перемещение, джеб, кросс, уклон)
	"block swoop" - блок, перемещение за блоком
	"swoop" - наскоки и отскоки
	"interrupt" - прерывание движения ударом
	"weave cross" - кросс сразу после уклона
	"double jab" - двойной джеб
	"power cross" - заряжание кросса
	"breakoff" - отбивы (нужно 2 соперника)
	
	"counter jab" - джеб сразу после пропущенного удара
--]]

local t, p, i

function tutorial.update_state(me, enemy, dt)
	t = me.mind.task.left_t
	t = t - dt
	if (t < 0) then
		-- новое действие
		p, i = me.mind.task.program, me.mind.task.index
		me.mind.action = { p[i][1], p[i][2] }
		me.mind.task.left_t = p[i][3]
		-- след. действие в списке
		i = i + 1
		if (p[i] ~= nil) then
			me.mind.task.index = i
		else
			-- [[ начинаем сначала
			me.mind.task.index = 1
			me.x = me.mind.start_x
			--]]
			-- след. задача
		end
	else
		me.mind.task.left_t = t
	end
end

local press, key

function tutorial.update_action(me, enemy, dt)
	if (me.mind.action ~= nil) then
		--if (key == 'none') then me.x = me.mind.start_x; return end
		key = me.mind.action[1]
		press = me.mind.action[2]
		if (press) then
			controls.keypressed(me, key)
			--debuginfo.text = debuginfo.text.."\npress: "..key
		else
			controls.keyreleased(me, key)
			--debuginfo.text = debuginfo.text.."\nrelease: "..key
		end
		me.used_buttons[key] = press
		me.mind.action = nil
	end
end

function tutorial.set_pos(me, new_x, new_y)
	me.mind.start_x = new_x
	me.x, me.y = new_x, new_y
end

local btn_ofs = {
	['left'] = {-24,4}, ['right'] = {-18,4}, ['up'] = {-12,4}, ['down'] = {-6,4}, ['z'] = {0,4}, ['x'] = {6,4}, ['tab'] = {12, 4}
}

function tutorial.draw_buttons(me)
	if (me.hide) then return end
	for k,v in pairs(me.used_buttons) do
		if (v) then lg.draw(buttons[k][1], buttons[k][2], me.mind.start_x+btn_ofs[k][1], me.y+btn_ofs[k][2]) end
	end
end