controls = {
	-- действие => кнопка
	player = { ['left'] = 'left', ['right'] = 'right', ['up'] = 'up', ['down'] = 'down', ['jab'] = 'z', ['cross'] = 'x', ['reverse'] = 'tab' },
	player1 = { ['left'] = 'a', ['right'] = 'd', ['up'] = 'w', ['down'] = 's', ['jab'] = 'f', ['cross'] = 'g', ['reverse'] = 'tab' },
	player2 = { ['left'] = 'left', ['right'] = 'right', ['up'] = 'up', ['down'] = 'down', ['jab'] = 'kp0', ['cross'] = 'kp.', ['reverse'] = 'rctrl' },
}

function controls.update(fighter, dt)
	if (fighter == nil or fighter.keys == nil) then return end
	-- остановка при движении, если отпустили кнопку "влево" или "вправо"
	if (fighter.state == nil) then
		if (lk.isDown(fighter.keys['left'])) then fighter:action('move', false); return end
		if (lk.isDown(fighter.keys['right'])) then fighter:action('move', true); return end
	end
	-- отпустили кнопку движения пока наш боксер шел => останавливаем движение
	if (fighter.state == 'block_step' or fighter.state == 'step' or fighter.state == 'walk' or fighter.state == 'reverse') then
		if (not lk.isDown(fighter.keys['left']) and not lk.isDown(fighter.keys['right'])) then fighter:action('stop') end
		return
	end
	-- в стойке
	if (fighter.fight_stance) then
		-- получили в ЩИ, но все еще держим кнопку блока => снова его ставим
		if (fighter.state == nil) then
			if (lk.isDown(fighter.keys['up'])) then fighter:action('block', true) end
		end	
	else
	
	end
end

-- нажатие кнопки
function controls.keypressed(fighter, key)
	if (fighter == nil or fighter.keys == nil) then return end
--	if (key == ' ' or key == 'space') then fighter:stance() end
	-- перемещения и развороты
	if (key == fighter.keys['reverse']) then fighter:action('reverse') end
	if (key == fighter.keys['right']) then fighter:action('move', true) end
	if (key == fighter.keys['left']) then fighter:action('move', false) end
	-- различия управления в стойке
	if (fighter.fight_stance) then
		if (key == fighter.keys['up']) then fighter:action('block', true) end
		if (key == fighter.keys['down']) then fighter:action('weave') end
		-- за блоком - отбивы, без блока - удары
		if (fighter.state == 'block') then
			if (key == fighter.keys['jab']) then fighter:action('beatoff', false) end
			if (key == fighter.keys['cross']) then fighter:action('beatoff', true) end
		else
			if (key == fighter.keys['jab']) then fighter:action('jab') end
			if (key == fighter.keys['cross']) then fighter:action('cross', true) end
		end
	else
		--  и без
		if (key == fighter.keys['up']) then fighter:action('move_up') end
		if (key == fighter.keys['down']) then fighter:action('move_down') end
		if (key == fighter.keys['jab']) then fighter:action('talk') end
		if (key == fighter.keys['cross']) then fighter:action('interact') end
		
	end
end

-- отпускание кнопки
function controls.keyreleased(fighter, key)
	if (fighter == nil or fighter.keys == nil) then return end
	if (fighter.fight_stance) then
		if (key == fighter.keys['left'] or key == fighter.keys['right']) then fighter:action('stop') end
		if (key == fighter.keys['up']) then fighter:action('block', false) end
		if (key == fighter.keys['cross']) then boxer.cross_release(fighter) end
	else
	
	end
end

-- сброс всех нажатий
function controls.reset(fighter)
	if (fighter == nil or fighter.keys == nil) then return end
	for action,key in pairs(fighter.keys) do
		if (lk.isDown(key)) then controls.keyreleased(fighter, key) end
	end
	fighter:reset()
end