TUTORIAL, MAIN_MENU, FIGHT = -1, 0, 1

campaign = {
	on = false, index = 1,
	list = {
		[1] = { ai = "novice", params = { 2,2,2,2 } },
		[2] = { ai = "amateur", params = { 3,3,3,4 } },
		[3] = { ai = "swarmer", params = { 2,4,5,3 } },
		[4] = { ai = "pro", params = { 4,4,4,4 } },
		[5] = { ai = "counter", params = { 4,3,2,2 } },
		[6] = { ai = "playman", params = { 3,4,4,3 } },
		[7] = { ai = "blocker", params = { 3,3,4,5 } },
		[8] = { ai = "spoiler", params = { 3,5,2,3 } },
	},
	max_lives = 3
}

local gui = { }

function campaign.init()
	gui.lives_icon = resources.get_sprite("gui", "lives_icon")
	local lives = { }
	lives[1] = resources.get_sprite("gui", "lives1"); lives[2] = resources.get_sprite("gui", "lives2")
	lives[3] = resources.get_sprite("gui", "lives3"); lives[4] = resources.get_sprite("gui", "lives4")
	lives[5] = resources.get_sprite("gui", "lives5")
	gui.lives = lives
end

function campaign.start()
	campaign.lives = campaign.max_lives
	campaign.index = 0
	campaign.on = true
	campaign.next_fight()
end

function campaign.minus_live()
	campaign.lives = math.clamp(campaign.lives-1, 0, campaign.max_lives)
end

function campaign.finish()
	campaign.on = false
end

-- переход к след. уровню
function campaign.next_fight()
	if (not campaign.on) then return end
	fight.finish()
	finish.on = false
	if (campaign.list[campaign.index+1] == nil) then
		-- конец кампании, возвращаемся в главное меню
		campaign.finish()
		level.exit()
		menu.enter(1, 1)
	else
		-- переход к след. уровню
		campaign.index = campaign.index + 1
		local fight_sett = campaign.list[campaign.index]
		local fight_agrs = { }
		fight_agrs[1] = { ai = "player", params = { 3, 3, 3, 3 } }
		fight_agrs[2] = { ai = fight_sett.ai, params = { fight_sett.params[1], fight_sett.params[2], fight_sett.params[3], fight_sett.params[4] } }
		fight.enter(level_names[campaign.index], fight_agrs[1], fight_agrs[2])
	end
end

fight = { mode = 0, num_players = 0, }

function start_fight_mode(me)
	boxer.switch_control(me)
	me.sprite = me.stance_sprite
end

local tutor_pos = { x = 80, y = 60 }

local player, player1, player2 = nil, nil, nil

local function bind_players()
	-- подсчитываем кол-во игроков-людей
	num_players = 0
	player, player1, player2 = nil, nil, nil
	if (enemy1 ~= nil and enemy1.mind == nil) then num_players = num_players + 1 end
	if (enemy2 ~= nil and enemy2.mind == nil) then num_players = num_players + 1 end
	-- назначаем им управление
	if (num_players == 1) then
		if (enemy1 ~= nil and enemy1.mind == nil) then
			player = enemy1
			player.controls_mode = 0
			player.keys = controls.player
		end
		if (enemy2 ~= nil and enemy2.mind == nil) then
			player = enemy2
			player.controls_mode = 0
			player.keys = controls.player
		end
	end
	if (num_players == 2) then
		if (enemy1 ~= nil) then player1 = enemy1; player1.controls_mode = 1; player1.keys = controls.player1 end
		if (enemy2 ~= nil) then player2 = enemy2; player2.controls_mode = 2; player2.keys = controls.player2 end
	end
end

function fight.enter(name, boxer1, boxer2)
	level.select(name, boxer1, boxer2)
	tutorial.set_pos(tutor, tutor_pos.x, tutor_pos.y)
	fight.tutorial(false)
	bind_players()
	if (num_players == 2) then help.show_controls() end
	set_state(fight)
end

function fight.create_tutor()
	tutor = actor.create(0, 0, "boxer", false)
	boxer.create(tutor, true, false)
	mind.connect(tutor, nil, 'tutorial')
	start_fight_mode(tutor)
	tutor.post_draw = tutorial.draw_buttons
	tutor.no_cast = true
	tutor.no_sound = true
	tutor.dont_destroy = true
end

local before_tutor_x = 50

function fight.tutorial(on)
	-- переключаем
	-- [[
	if (on == nil) then
		on = (fight.mode ~= TUTORIAL)
	end
	if (on) then
		tutor.hide = false
		fight.mode = TUTORIAL
	else
		tutor.hide = true
		fight.mode = FIGHT
	end
end

function fight.finish()
	if (enemy1 ~= nil) then mind.disconnect(enemy1) end
	if (enemy2 ~= nil) then mind.disconnect(enemy2) end
	player, player1, player2 = nil, nil, nil
	level.exit();
end

local hold_h = false

function fight.update(dt)
	-- справка по управлению во время боя
	if (hold_h) then help.show_controls() end
	help.update(dt)
	-- обновление поединка
	if (enemy1 ~= nil and enemy1.mind == nil) then controls.update(enemy1, dt) end
	if (enemy2 ~= nil and enemy2.mind == nil) then controls.update(enemy2, dt) end
	if (gameplay_pause_update(dt)) then return end
	animation.update(dt)
	object.update_all(dt)
	collision.update(dt)
end

function fight.draw()
	level.draw_layer(0)
		object.draw_all()
		lg.setShader()
	level.draw_layer(1)
	object.post_draw_all()
	lg.setColor(color.white)
	
	if (is_pause) then
		lg.setColor(color.pause_fog)
		lg.rectangle('fill', 0, 0, screen.width, screen.height)
		lg.setColor(color.white)
		lg.printf("[ PAUSE ]", 54, 40, 50, 'center')
	end
	
	lg.setColor(color.white)
	if (campaign.on) then
		-- кол-во жизней
		if (campaign.lives > 0) then
			lg.setColor(0,0,0,128)
			lg.rectangle('fill', 0, 0, 21, 12)
			lg.setColor(color.red2)
			lg.draw(gui.lives_icon[1], gui.lives_icon[2])
			lg.setColor(color.white3)
			lg.draw(gui.lives[campaign.lives][1], gui.lives[campaign.lives][2], 12, 1)
		end
	else
		-- справка
		help.draw()
	end	

	lg.setColor(color.white)
	if (fight.mode == TUTORIAL) then
		lg.printf(locale.get_text('help', 'change_move'), 5, 6, screen.width-6, 'right')
	end
	
	-- победа
	if (finish.on) then
		if (finish.victory) then
			lg.setColor(color.green2)
			lg.rectangle('fill', 42, 32, 74, 14)
			lg.setColor(color.green3)
			if (campaign.on and campaign.index == #campaign.list) then
				lg.printf(locale.get_text('fight', 'complete'), 0, 34, screen.width, 'center')
			else
				lg.printf(locale.get_text('fight', 'victory'), 0, 34, screen.width, 'center')			
			end
		else
			lg.setColor(color.red2)
			lg.rectangle('fill', 42, 32, 74, 14)
			lg.setColor(color.red3)
			-- гейм-овер или просто поражение
			if (campaign.on and campaign.lives == 0) then
				lg.printf(locale.get_text('fight', 'gameover'), 0, 34, screen.width, 'center')
			else
				lg.printf(locale.get_text('fight', 'defeat'), 0, 34, screen.width, 'center')
			end
		end
		lg.setColor(color.white)
	end
	
	if (is_debug) then collision.draw_cast() end
end

function fight.keypressed(key)
	-- бой закончился
	--if (key == 'return' or key == 'space') then
		if (finish.on and campaign.on and not pause) then
			if (finish.victory) then campaign.next_fight(); -- след. бой в кампании
			else
				-- закончились жизни => в главное меню!
				if (campaign.lives == 1) then campaign.finish(); level.exit(); menu.enter(1, 1)
				else restart() end
			end
			return;
		end
	--end
	
	-- переключение паузы и справки
	if (key == 'return' or key == 'space') then switch_pause(); return end
	if (key == 'f1') then help.show = not help.show; return end
	if (key == 'h') then hold_h = true return end
	if (is_pause) then return end
	
	if (fight.mode == TUTORIAL) then
		if (key == 'y') then select.change_tutor_move(-1) end
		if (key == 'u') then select.change_tutor_move(1) end
	end
	--[[
	if (key == '1') then mind.connect(enemy, 'bag'); restart() end
	if (key == '2') then mind.connect(enemy, 'novice'); restart() end
	if (key == '3') then mind.connect(enemy, 'amateur'); restart() end
	if (key == '4') then mind.connect(enemy, 'counter'); restart() end
	if (key == 'e') then restart_enemy() end
	if (key == 'q') then restart_player() end
	--]]
	-- [[
	if (key == '[') then finish_fight(true) end
	if (key == ']') then finish_fight(false) end
	--]]
	-- в паузе управление сюда не попадает:
	if (key == 'escape' or key == 'backspace') then
		fight.finish();
		if (campaign.on) then campaign.finish(); menu.enter(1, 1) else select.enter(); end
		return
	end
	if (key == 'r') then restart(); return end
	if (key == 't') then fight.tutorial(); return end
	
	-- передача управления бойцу
	if (enemy1 ~= nil and enemy1.mind == nil) then controls.keypressed(enemy1, key) end
	if (enemy2 ~= nil and enemy2.mind == nil) then controls.keypressed(enemy2, key) end
end

function fight.keyreleased(key)
	if (key == 'h') then hold_h = false; return end
	if (is_pause) then return end
	if (enemy1 ~= nil and enemy1.mind == nil) then controls.keyreleased(enemy1, key) end
	if (enemy2 ~= nil and enemy2.mind == nil) then controls.keyreleased(enemy2, key) end
end