level = { lx = 0, rx = 255, can_fall = false }

local layers = { }

function level.exit()
	audio.stop_ambient(name)
	enemy1, enemy2 = nil, nil
	object.destroy_all()
end

function level.load(name)
	layers[0] = lg.newImage("levels/"..name.."/back.png")
	layers[1] = lg.newImage("levels/"..name.."/front.png")
end

function level.move_pos(me, dx)
	if (me.is_alive) then
		me.x = math.clamp(me.x + dx, level.lx, level.rx)
	else
		me.x = math.clamp(me.x + dx, 0, 320)
	end
	-- упали с крыши
	if (me.is_alive and level.can_fall) then
		if (me.x + dx < level.lx and me.side > 0) then
			me:death(FALL)
			debuginfo.text2 = "fall death left"
		end
		if (me.x + dx > level.rx and me.side < 0) then
			me:death(FALL)
			debuginfo.text2 = "fall death right"
		end
	end
end

function level.draw_layer(l)
	if (layers[l] ~= nil) then lg.draw(layers[l]) end
end

shader_param = 0
local spawn1, spawn2 = 0, 0
local start_x, start_y = 67, 88
local name_form = "boxer"
enemy1, enemy2 = nil, nil

function level.select(name, boxer1, boxer2)
	-- загрузка уровня
	lg.setBackgroundColor(fight_background_color)
	audio.play_ambient(name)
	if (name == 'abstract') then start_abstract() end
	if (name == 'boxing') then start_boxing() end
	if (name == 'street') then start_street() end
	if (name == 'storage') then start_storage() end
	if (name == 'pirates') then start_pirates() end
	if (name == 'prison') then start_prison() end
	if (name == 'park') then start_park() end
	if (name == 'roof') then start_roof() end
	shaders.set_value("recolor", "mode", shader_param)
--	debuginfo.text2 = "x = "..start_x.."; y = "..start_y
	-- первый боец
	enemy1 = actor.create(spawn1, start_y, name_form, true)
	boxer.create(enemy1, true, true)
	boxer.set_params(enemy1, boxer1.params)
	start_fight_mode(enemy1)
	-- второй боец
	enemy2 = actor.create(spawn2, start_y, name_form, false)
	boxer.create(enemy2, true, false)
	boxer.set_params(enemy2, boxer2.params)
	start_fight_mode(enemy2)
	-- игрок / ИИ
	if (boxer1.ai ~= 'player') then mind.connect(enemy1, enemy2, boxer1.ai) end
	if (boxer2.ai ~= 'player') then mind.connect(enemy2, enemy1, boxer2.ai) end
	--
	debuginfo.text = "start "..name
end

function start_abstract()
	level.load('abstract')
	spawn1, spawn2 = 50, 108
	level.lx, level.rx = 32, 130
	level.can_fall = true
	start_y = 102
	name_form = "boxer"
	shader_param = 0
end

function start_boxing()
	level.load('boxing_ring')
	spawn1, spawn2 = 50, 108
	level.lx, level.rx = 23, 137
	level.can_fall = false
	start_y = 88
	name_form = "boxer_ring"
	shader_param = 1
end

function start_street()
	level.load('street')
	level.lx, level.rx = 27, 121
	spawn1, spawn2 = 50, 108
	level.can_fall = false
	start_y = 115
	name_form = "boxer_street"
	shader_param = 2
end

function start_storage()
	level.load('storage')
	level.lx, level.rx = 12, 148
	spawn1, spawn2 = 50, 108
	level.can_fall = false
	start_y = 110
	name_form = "boxer_storage"
	shader_param = 3
end

function start_pirates()
	level.load('pirates')
	--level.lx, level.rx = 55, 102
	level.lx, level.rx = 48, 114
	spawn1, spawn2 = 66, 98
	level.can_fall = true
	start_y = 99
	name_form = "boxer_pirates"
	shader_param = 4
end

function start_prison()
	level.load('prison')
	level.lx, level.rx = 23, 132
	spawn1, spawn2 = 66, 98
	level.can_fall = false
	start_y = 114
	name_form = "boxer_prison"
	shader_param = 5
end

function start_park()
	level.load('park')
	level.lx, level.rx = 10, 150
	spawn1, spawn2 = 60, 100
	level.can_fall = false
	start_y = 111
	name_form = "boxer_street"
	shader_param = 2
end

function start_roof()
	level.load('roof')
	level.lx, level.rx = 34, 130
	spawn1, spawn2 = 50, 108
	level.can_fall = true
	start_y = 85
	name_form = "boxer_roof"
	shader_param = 6
end
