--require('resources')

locale = { }
text = { }
require("locale/eng")
require("locale/rus")

local table_begin = "0123456789 "
local symbols = {
	['rus']="абвгдеёжзийклмнопрстуфхцчшщьыъэюяАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЬЫЪЭЮЯ",
	['eng']="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",
}
local empty_string = {
	['rus']="ХХХ",
	['eng']="XXX",
}
local table_end = "+-*`=.,!?:;'\"()[]{}<>\\/|~@#$%^&_"

language = 'eng' --'rus'
language_list = { 'eng', 'rus' }

local list = { }
local cur_font, last_font

function locale.init()
end

function locale.load_fonts()
	-- мелкий шрифт
	local image = love.graphics.newImage('locale/font_text.png')
	say_font = locale.new_font('text', image)
	-- крупный шрифт
	image = love.graphics.newImage('locale/font_screen.png')
	locale.new_font('screen', image)
end

local extra_space = 1

function locale.new_font(name, image_font)
	local glyph_array = table_begin..symbols['eng']..symbols['rus']..table_end
	last_font = love.graphics.newImageFont(image_font, glyph_array, extra_space)
	-- add font in list
	list[name] = last_font
	return last_font
end

-- switch to another language (don't forget select new font next!)
function locale.select_lang(lang)
	language = lang
end

function locale.get_lang()
	return language
end

-- switch to another font of current language
function locale.select_font(font_name)
	if list[font_name] ~= nil then
		cur_font = font_name
		love.graphics.setFont(list[font_name])
	else return; end
end

function locale.get_text(group, key)
	char = text[language][group]
	if (char ~= nil) then
		if (key ~= nil) then str = char[key] else str = "???" end
		return str or empty_string[language]
	end
	return empty_string[language]
end