menu = { index = 0 }

bg_color = { 64, 64, 64, 255 }
logo, hands = nil, nil

local back = nil
local cur_menu = nil

list = {
	[0] = { "tutorial", "start", "settings", "authors", "quit" },
	--[1] = { "campaign", "custom_fight", "multiplayer", "back" },
	[1] = { "campaign", "custom_fight", "back" },
}
local sel_item = 1

function menu.switch(index, new_sel)
	menu.index = index or 0
	cur_menu = list[index]
	sel_item = new_sel or 1
end

local back_colors = { color.orange, color.green3, color.blue2, color.red2, color.white2, color.pink }
local sel_back_color = 1

local scales = { {1,1}, {-1,1}, {-1,-1}, {1,-1}, }
local back_scale = nil

function menu.enter(index, sel)
	if (back == nil) then back = resources.get_image("back_menu") end
	-- случайный цвет
	local back_index = math.ceil(math.random() * #back_colors)
	sel_back_color = back_colors[back_index]
	-- случайная инверсия задника
	local scale_index = math.ceil(math.random() * #scales)
	back_scale = scales[scale_index]
	--
	if (index == nil or index == 0) then menu.switch(0, sel) end
	if (index ~= nil and index == 1) then menu.switch(1, sel) end
	lg.setBackgroundColor(bg_color)
	if (logo == nil) then logo = resources.get_image("logo") end
	if (hands == nil) then hands = resources.get_image("logo_icon") end
	set_state(menu)
	audio.play_ambient("menu")
end

function menu.leave()
	lg.setBackgroundColor(fight_background_color)
end

function menu.change_item(inc)
	sel_item = math.clamp_loop(sel_item+inc, 1, #cur_menu)
	audio.play_sound('select')
end

function menu.click_item()
	audio.play_sound('select_menu')
	if (menu.index == 0) then
		--  главное меню
		if (sel_item == 1) then select.enter(2) end
		if (sel_item == 2) then menu.switch(1, 1) end
		if (sel_item == 3) then settings.enter() end
		if (sel_item == 4) then authors.enter() end
		if (sel_item == #cur_menu) then quit() end
	else
		-- выбор игрового режима
		if (sel_item == 1) then campaign.start() end
		if (sel_item == 2) then select.enter() end
		--if (sel_item == 3) then network.enter() end
		--if (sel_item == 4) then menu.switch(0, 2) end
		if (sel_item == 3) then menu.switch(0, 2) end
	end
end

local t = 0
local bg_min, bg_amp, bg_val = 64, 64, 128
local logo_color = { 0, 0, 0, 255 }
local ft = 0
local fg_min, fg_amp, fg_val = 132, 16, 128
local fg_color = { 0, 0, 0, 255 }

function menu.update(dt)
	t = t + dt
	bg_val = bg_min + (math.sin(2*t) * bg_amp)
	logo_color[1], logo_color[2], logo_color[3] = (128-bg_val), 0, bg_val
	ft = ft + 4*dt
	fg_val = fg_min + (math.sin(ft) * fg_amp)
	fg_color[1], fg_color[2], fg_color[3] = fg_val, fg_val, fg_val
end

local start_y, y, step_y, i = 58, 0, 11, 1

function menu.draw()
	-- рисуем фоновый задник
	lg.setColor(sel_back_color)
	lg.draw(back, -80*(back_scale[1]-1), -60*(back_scale[2]-1), 0, back_scale[1], back_scale[2])
	-- логотип
	lg.setColor(logo_color)
	lg.draw(logo, 15, 2)
	-- перчатки
	lg.setColor(color.white)
	lg.draw(hands, screen.width/2-32, 11)
	-- пункты меню
	lg.setColor(color.gray2)
		for i = 1,#cur_menu,1 do
			y = start_y - (i-1)*step_y
			--if (sel_item == i) then lg.setColor(color.white2) end
			if (sel_item == i) then lg.setColor(fg_color) end
			lg.printf(locale.get_text("menu", cur_menu[i]), 0, screen.height - y, screen.width, 'center')
			if (sel_item == i) then lg.setColor(color.gray2) end
		end
	lg.setColor(color.white)
	lg.printf(version, screen.width-54, screen.height-12, 50, 'right')
end

function menu.keypressed(key)
	-- переключение между пунктами меню и выбор пункта
	if (key == 'up' or key == 'w') then menu.change_item(-1) end
	if (key == 'down' or key == 's') then menu.change_item(1) end
	if (key == 'space' or key == 'return') then menu.click_item() end
	-- выход в главное меню или из игры (если мы уже в главном меню)
	if (key == 'escape' or key == 'backspace') then
		if (menu.index ~= 0) then menu.switch(0, 2)
		else quit() end
	end
end

function menu.keyreleased(key)
end


authors = { }

function authors.update(dt)
end

function authors.draw()
	lg.printf("ProtoBox "..version, 0, 6, screen.width, 'center')
	lg.printf(locale.get_text('menu', 'authors_list'), 0, 24, screen.width, 'center')
end

function authors.enter()
	lg.setBackgroundColor(select_background_color)
	set_state(authors)
end

function authors.leave()
end

function authors.keypressed(key)
	authors.leave()
	menu.enter(0, 4)
end

function authors.keyreleased(key)
end