DIST_NONE, DIST_CLOSE, DIST_NORMAL, DIST_FAR, DIST_VERY_FAR = 0, 1, 2, 3, 4
AI_ATTACK, AI_DEFEND = 4, 5

AI_NONE, AI_STEP, AI_BACK, AI_TOO_FAR = 0, 1, -1, -1

mind = { }

function mind.connect(me, other, ai_name)
	-- создаем новый искуственный разум
	local period = 0.5
	local m = { body = me, period = period, timer = period, dist = 0, side = 0, state = AI_NONE, enemy = other, }
	-- подключаем к телу мозг
	m.update_state = _G[ai_name].update_state
	m.update_action = _G[ai_name].update_action
	me.mind = m
	me.mind.update = mind.update
	_G[ai_name].init(me)
	return mind
end

function mind.disconnect(me)
	me.mind = nil
end

function mind.set_pause(me, value)
	me.mind.timer = value
end

function mind.add_pause(me, value)
	me.mind.timer = me.mind.timer + value
end

local dist, side

local function update_data(me, enemy, dt)
	if (enemy == nil or me == nil) then return end
	dist = enemy.x - me.x
	side = math.sign(dist)
	me.mind.dist, me.mind.side = math.abs(dist), side
end

local function update_timer(me, dt)
	me.mind.timer = me.mind.timer - dt
	if (me.mind.timer < 0) then
		me.mind.timer = me.mind.timer + me.mind.period
		return true
	end
	return false
end

local after_damage

function mind.update(me, dt)
	-- отключаем соперника во время туториала и если он победил игрока
	if (me == enemy1 or me == enemy2) then
		--if (player ~= nil and not player.is_alive) then return end
		if (me.mind.enemy ~= nil and not me.mind.enemy.is_alive) then return end
		if (fight.mode == TUTORIAL) then return end
	end
	-- после урона сразу вызываем обновление состояния
	after_damage = (me.state == nil and me.prev_state == 'damage')
	if (update_timer(me, dt) or after_damage) then
		update_data(me, me.mind.enemy, dt)
		me.mind.update_state(me, me.mind.enemy, dt)
		me.mind.update_action(me, me.mind.enemy, dt)
	end
end
