screen = { }

fullscreen = false

function screen.init()
	screen.width, screen.height = 160, 120
	desktop_width, desktop_height = lw.getDesktopDimensions()
end

local window_scale = 0
local sel_res, new_res = 2, 2
local resolutions = {
	[1] = {320, 240, 2}, [2] = {640, 480, 4}, [3] = {960, 720, 6}, [4] = {1280, 960, 8},
}

function set_scale(new_value)
	sel_res = new_value
end

function get_scale()
	return sel_res
end

function toggle_fullscreen()
	fullscreen = not fullscreen
	local width, height
	if (fullscreen) then
		lw.setFullscreen(true, "desktop")
		window_scale = scale	-- запоминаем масштаб в окне
		scale = desktop_height / screen.height	-- подгоняем положение камеры и масштаб под размер экрана
		offset_x = (desktop_width - scale*screen.width)/2
	else
		lw.setFullscreen(false)
		scale = window_scale	-- восстанавливаем масштаб
		offset_x = 0
	end
	update_size()
end

function change_resolution(change)
	if (fullscreen) then return end
	new_res = math.clamp(sel_res + change, 1, 4)
	--if (sel_res == new_res) then return end
	set_window_mode(new_res)
	update_size()
end

function set_window_mode(index)
	local screen_size = resolutions[index]
	if (screen_size == nil) then return end
	-- меняем размер окна
	local temp1, temp2, flags = lw.getMode()
	scale = screen_size[3]
	flags.centered = true
	flags.x, flags.y = (desktop_width - screen_size[1])/2, (desktop_height - screen_size[2])/2
	lw.setMode(screen_size[1], screen_size[2], flags)
	window.width, window.height = screen_size[1], screen_size[2]
	sel_res = index
end

function update_size()
	window.width, window.height, window.flags = lw.getMode()
	shaders.set_value("recolor", "mode", shader_param or 0)
end