// АБСТРАКТ
//vec4 gray = vec4(0.05, 0.05, 0.05, 1.0);
vec4 gray = vec4(0.10, 0.10, 0.10, 1.0);
// БОКС
vec4 blue = vec4(0.20703125, 0.2109375, 0.68359375, 1.0);
vec4 skin = vec4(0.81, 0.64, 0.58, 1.0);
// УЛИЦА
vec4 light_t = vec4(0.30, 0.18, 0.18, 1.0);
vec4 light_d = vec4(0.19, 0.22, 0.234, 1.0);
// СКЛАД
vec4 hands = vec4(0.4, 0.5, 0.7, 1.0);
vec4 tshirt = vec4(0.84, 0.88, 0.88, 1.0);
vec4 pants = vec4(0.6, 0.62, 0.68, 1.0);
// ПИРАТЫ
vec4 black_skin = vec4(0.42, 0.24, 0.19, 1.0);
vec4 blue2 = vec4(0.16, 0.20, 0.33, 1.0);
// ТЮРЬМА
vec4 top_skin = vec4(0.72, 0.76, 0.78, 1.0);
vec4 bot_skin = vec4(0.77, 0.70, 0.68, 1.0);
// КРЫША
vec4 red1 = vec4(0.4336, 0.125, 0.125, 1.0);
vec4 red2 = vec4(0.38, 0.125, 0.125, 1.0);

extern number mode = 0;

vec4 effect(vec4 color, Image tex, vec2 tc, vec2 sc)
{
    vec4 pixel = Texel(tex, tc);
	float sum = pixel.r + pixel.g + pixel.b;
	
	// ЧЕРНЫЙ-СЕРЫЙ
	if (mode == 0) {
		if (sum >= 0.0f && sum < 0.01f) {
			pixel.r = gray.r; pixel.g = gray.g; pixel.b = gray.b;
		}
	}
	
	// БОКСЕР
	if (mode == 1) {
		// заменяем красный на синий
		if (sum > 1.05f && sum < 1.06f) {
			pixel.r = blue.r; pixel.g = blue.g; pixel.b = blue.b;
		}
		// меняем цвет кожи
		if (sum > 2.04f && sum < 2.05f) {
			pixel.r = skin.r; pixel.g = skin.g; pixel.b = skin.b;
		}
	}
	
	// УЛИЦА
	if (mode == 2) {
		if (sum > 0.69f && sum < 0.71f) {
			pixel.r = light_t.r; pixel.g = light_t.g; pixel.b = light_t.b;
		}
		if (sum > 0.50f && sum < 0.51f) {
			pixel.r = light_d.r; pixel.g = light_d.g; pixel.b = light_d.b;
		}
	}

	// СКЛАД
	if (mode == 3) {
		if (sum > 1.60f && sum < 1.63f) {
			pixel.r = hands.r; pixel.g = hands.g; pixel.b = hands.b;
		}
		if (sum > 2.29f && sum < 2.32f) {
			pixel.r = tshirt.r; pixel.g = tshirt.g; pixel.b = tshirt.b;
		}
		if (sum > 1.88f && sum < 1.91f) {
			pixel.r = pants.r; pixel.g = pants.g; pixel.b = pants.b;
		}
	}
	
	// ПИРАТЫ
	if (mode == 4) {
		//if (sum > 2.20f && sum < 2.22f) {
		if (sum > 2.1f && sum < 2.3f) {
			pixel.r = black_skin.r; pixel.g = black_skin.g; pixel.b = black_skin.b;
		}
		// заменяем красный на синий
		if (sum > 0.99f && sum < 1.01f) {
			pixel.r = blue2.r; pixel.g = blue2.g; pixel.b = blue2.b;
		}
		// заменяем синий на красный
		if (sum > 0.69f && sum < 0.71f) {
			pixel.r = red2.r; pixel.g = red2.g; pixel.b = red2.b;
		}
	}
	
	// ТЮРЬМА
	if (mode == 5) {
		if (sum > 1.97f && sum < 1.99f) {
			pixel.r = top_skin.r; pixel.g = top_skin.g; pixel.b = top_skin.b;
		}
		if (sum >= 1.90f && sum < 1.91f) {
			pixel.r = bot_skin.r; pixel.g = bot_skin.g; pixel.b = bot_skin.b;
		}
	}
	
	// КРЫША
	if (mode == 6) {
		if (sum > 0.37f && sum < 0.38f) {
			pixel.r = red1.r; pixel.g = red1.g; pixel.b = red1.b;
		}
		if (sum >= 0.0f && sum < 0.01f) {
			pixel.r = red2.r; pixel.g = red2.g; pixel.b = red2.b;
		}
	}
	
	return pixel * color;
}
