-- CONVERSION
bool_to_dir = { [false] = -1, [true] = 1 }
bool_to_str = { [false] = 'false', [true] = 'true' }
bool_to_number = { [false] = 0, [true] = 1 }
number_to_bool = { [0] = false, [1] = true }

-- MATH

function math.sign(value)
	if (value < 0) then return -1
	else return 1 end
end

function math.clamp(value, min, max) -- огранич. значение минимумом и максимумом
	return math.max(math.min(value, max), min)
end

function math.clamp_loop(value, min, max) -- зацикленное ограничение
	if (value < min) then return max end
	if (value > max) then return min end
	return math.max(math.min(value, max), min)
end


-- LOGIC

function xor(cond1, cond2) -- искл. логическое "ИЛИ" (XOR)
	return (cond1 ~= cond2)
end

-- PHYSICS

-- x, y - левый нижний угол прямоугольника,    sx, sy - длина вправо и высота вниз
function rect_vs_rect(x1,y1,sx1,sy1, x2,y2,sx2,sy2) -- between 2 AABB
	if (x1 < x2 and x1+sx1 < x2 or x2 < x1 and x2+sx2 < x1) then return false; end
	if (y1 < y2 and y2-sy2 > y1 or y2 < y1 and y1-sy1 > y2) then return false; end
	return true;
end
